// Read Sensors
int Read_Ping_Sensor() {
  int cm=0;
  //trigger the sensor
  unsigned long value = 0;
  pinMode(PingPin, OUTPUT);
  digitalWrite(PingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(PingPin, HIGH);
  delayMicroseconds(5);
  digitalWrite(PingPin, LOW);
  //receive the echo
  pinMode(PingPin, INPUT);
  digitalWrite(PingPin, HIGH); // turn on pull up resistor
  value = pulseIn(PingPin, HIGH);
  value=value/58.138;
  cm=int(value);
  return cm;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int Read_Sharp_Sensor(byte model, byte pin) {
  int value = 0;
  value = analogRead(pin);
  //if (value<70)value=70;
  switch (model) {
    case SR:
      return (2914/(value+5))-1; // for GP2D120 (4-30cm)
      break;
    case MR:
      return 1384.4*pow(value,-.9988); // for GP2D12 (10-80cm)
      break;
    case LR:  
      return 11441*pow(value,-.9792); // for GP2Y0A02YK (20-150cm)
      //return 7715.1*pow(value,-.8767); // for GP2Y0A02YK (15-150cm)
      break;
  }
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void Read_Thermopile_Array(){
  for(byte i = 0; i < 9; i++){              // Loops and stores temperature data in array
    temperature[i] = I2C_read(Thermo, i+1); // address, register
  }
}

int I2C_read(int addr, int reg){    // Function to receive one byte of data from slave
  Wire.beginTransmission(addr);       // Begin communication with slave
  Wire.send(reg);                     // Send register to slave
  Wire.endTransmission();
  Wire.requestFrom(addr, 1);          // Request 1 byte
  while(Wire.available() < 1);        // Wait for byte to arrive
  int data = Wire.receive();          // Get byte
  return(data);                       // return byte
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void Read_Compass_Sensor(){
  // Send a "A" command to the HMC6352
  // This requests the current heading data
  Wire.beginTransmission(0x21);
  Wire.send(0x41);              // The "Get Data" command
  Wire.endTransmission();
  delay(1);                   // The HMC6352 needs at least a 70us (microsecond) delay
  // after this command.  Using 7ms just makes it safe
  // Read the 2 heading bytes, MSB first
  // The resulting 16bit word is the compass heading in 10th's of a degree
  // For example: a heading of 1345 would be 134.5 degrees
  Wire.beginTransmission(0x21);
  Wire.requestFrom(0x21, 2);        // Request the 2 byte heading (MSB comes first)
  j = 0;
  while(Wire.available())
  {
    char c = Wire.receive();
    headingData[j] = c;
    j++;
  }
  Wire.endTransmission();
  //Serial.print("Heading = ");
  frac = headingData[0]*256 + headingData[1];
  int h=map(frac, 0, 3600, 0, 15);
  deg = frac / 10;
  frac = frac - deg * 10;
  /*Serial.print(deg);
  Serial.print(".");
  Serial.println(frac);*/
    //Print heading as: deg.frac
    itoa(deg, byteString, 10);
    strcpy(text, byteString);
    if (deg<100){ 
      lcd.cLCD_String(" ", 47, 114, CYAN,BLACK);
      lcd.cLCD_String(text, 55, 114, CYAN,BLACK);
    }else if (deg<10){
      lcd.cLCD_String("  ", 47, 114, CYAN,BLACK);
      lcd.cLCD_String(text, 63, 114, CYAN,BLACK);
    }else{
      lcd.cLCD_String(text, 47, 114, CYAN,BLACK);
    }
    lcd.cLCD_String(".", 71, 114, CYAN,BLACK);
    itoa(frac, byteString, 10);
    strcpy(text, byteString);
    lcd.cLCD_String(text, 79, 114, CYAN,BLACK);
  //int h=map(deg, 1, 360, 0, 15);
  /*switch (h){
    case 0:
      lcd.cLCD_String(" N", 96, 114, RED,LIGHTBLUE);
    case 1:
      lcd.cLCD_String("NE", 96, 114, RED,LIGHTBLUE);
    case 2:
      lcd.cLCD_String("NE", 96, 114, RED,LIGHTBLUE);
    case 3:
      lcd.cLCD_String(" E", 96, 114, RED,LIGHTBLUE);
    case 4:
      lcd.cLCD_String(" E", 96, 114, RED,LIGHTBLUE);
    case 5:
      lcd.cLCD_String("SE", 96, 114, RED,LIGHTBLUE);
    case 6:
      lcd.cLCD_String("SE", 96, 114, RED,LIGHTBLUE);
    case 7:
      lcd.cLCD_String(" S", 96, 114, RED,LIGHTBLUE);
    case 8:
      lcd.cLCD_String(" S", 96, 114, RED,LIGHTBLUE);
    case 9:
      lcd.cLCD_String("SW", 96, 114, RED,LIGHTBLUE);
    case 10:
      lcd.cLCD_String("SW", 96, 114, RED,LIGHTBLUE);
    case 11:
      lcd.cLCD_String(" W", 96, 114, RED,LIGHTBLUE);
    case 12:
      lcd.cLCD_String(" W", 96, 114, RED,LIGHTBLUE);
    case 13:
      lcd.cLCD_String("NW", 96, 114, RED,LIGHTBLUE);
    case 14:
      lcd.cLCD_String("NW", 96, 114, RED,LIGHTBLUE);
    case 15:
      lcd.cLCD_String(" N", 96, 114, RED,LIGHTBLUE); 
  }*/
  itoa(h, byteString, 10);
  strcpy(text, byteString);
  lcd.cLCD_String(text, 116, 114, RED,LIGHTBLUE); 
  if (h<10) lcd.cLCD_String(" ", 124, 114, RED,LIGHTBLUE); 
}

